// A killing spree/killing streak plugin by Duca.
// Exactly like the LOGD one.
// Thanks to PsychoGuard and JustinHoMi for providing
// a template with their Killing Spree Plugin.
//
// This plugin works only in combination with StatsMe by OLO.
// http://www.olo.counter-strike.pl/
//
// For questions, enhancements and requests have a look at the
// forums at http://www.unitedadmins.com/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define LEV128 1<<7
#define ACCESS_CONSOLE 131072

new VERSION[MAX_DATA_LENGTH] = "2.1.16.3";
new kills[MAX_PLAYERS] = {0, ...};
new deaths[MAX_PLAYERS] = {0, ...};

new level1 = 3;
new level2 = 5;
new level3 = 7;
new level4 = 9;
new level5 = 10;


public sm_killstreak_rstrt(HLCommand, HLData, HLUserName, UserIndex) {
    new name[MAX_NAME_LENGTH];
    new msg[MAX_TEXT_LENGTH];
    new user_index;
    new temp[MAX_DATA_LENGTH];

    convert_string(HLData, temp, MAX_DATA_LENGTH);
    user_index = strtonum(temp);
    
    if (playerinfo(user_index, name, MAX_NAME_LENGTH) != 0) {
	if (kills[user_index] > level1) {
	    snprintf(msg, MAX_TEXT_LENGTH, "You are on a killstreak with %d kills.",
		     kills[user_index]);
	    messageex(name, msg, print_chat);
	} else if (deaths[user_index] > 1) {
	    snprintf(msg, MAX_TEXT_LENGTH,
		     "Take care, you are on a deathstreak with %d deaths in a row.",
		     deaths[user_index]);
	    messageex(name, msg, print_chat);
	}
    }

    return PLUGIN_CONTINUE;
}


public sm_killstreak_stats(HLCommand, HLData, HLUserName, UserIndex) {
    if (auth("") != 1 || access(LEV128, "") != 1) {
	selfmessage("You don't have access to that command.");
	return PLUGIN_CONTINUE;
    }

    new calling_user[MAX_NAME_LENGTH];
    new name[MAX_NAME_LENGTH];
    new msg[MAX_TEXT_LENGTH];
    new i;

    convert_string(HLUserName, calling_user, MAX_NAME_LENGTH);

    for (i = 1; i <= maxplayercount(); i++) {
	if (playerinfo(i, name, MAX_NAME_LENGTH) != 0) {
	    if (kills[i] > 0) {
		snprintf(msg, MAX_TEXT_LENGTH, "%s is on a killstreak with %d kills.", name, kills[i]);
	    } else if (deaths[i] > 0) {
		snprintf(msg, MAX_TEXT_LENGTH, "%s is on a deathstreak with %d deaths.", name, deaths[i]);
	    } else {
		snprintf(msg, MAX_TEXT_LENGTH, "%s has just joined.", name);
	    }
	    selfmessage(msg);
	}
    }

    return PLUGIN_CONTINUE;
}

public sm_killstreak_event(HLCommand, HLData, HLUserName, UserIndex) {
    new msg[MAX_DATA_LENGTH];
    new receiver[4], killer[4], victim[4], headshot[4], weapon[4];

    convert_string(HLData, msg, MAX_DATA_LENGTH);
    strsplit(msg, " ",
	     receiver, 4, killer, 4, victim, 4, headshot, 4, weapon, 4);

    new killer_index = strtonum(killer);
    new victim_index = strtonum(victim);

    kills[killer_index] += 1;
    kills[victim_index] = 0;
    deaths[killer_index] = 0;
    deaths[victim_index] += 1;

    if (kills[killer_index] == level1) {
	announce(killer_index, "%s: Multi-Kill!", "misc/multikill", 255, 255, 255);

    }

    if (kills[killer_index] == level2) {
	announce(killer_index, "%s: Ultra-Kill!!!", "misc/ultrakill", 255, 10, 255);
    }

    if (kills[killer_index] == level3) {
	announce(killer_index, "%s IS ON A KILLING SPREE!!!", "misc/killingspree", 255, 15, 15);
    }

    if (kills[killer_index] == level4) {
	announce(killer_index, "%s A MONSTER.", "misc/monsterkill", 47, 82, 244);

    }

    if (kills[killer_index] == level5) {
	announce(killer_index, "%s A GODLIKE.", "misc/godlike", 247, 255, 29);

    }

    return PLUGIN_CONTINUE;
}


announce(killer_index, format[], sound[], r, g, b) {
    new name[MAX_NAME_LENGTH];
    new msg[MAX_TEXT_LENGTH];
    new command[MAX_DATA_LENGTH];

    if (playerinfo(killer_index, name, MAX_NAME_LENGTH) != 0) {
        snprintf(msg, MAX_TEXT_LENGTH, format, name);
        typesay(msg, 10, r, g, b);
        snprintf(command, MAX_DATA_LENGTH, "sm_clexec * ^"spk %s^"", sound);
        exec(command);
    }
}

public plugin_connect(HLUserName, HLIP, UserIndex) {
    if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
	kills[UserIndex] = 0;
	deaths[UserIndex] = 0;
    }

    return PLUGIN_CONTINUE;
}


public plugin_init() {
    plugin_registerinfo("Killstreak", "Killstreak Announcer", VERSION);
    plugin_registercmd("sm_killstreak_event",
		       "sm_killstreak_event",
		       ACCESS_CONSOLE, "");
    plugin_registercmd("sm_killstreak_rstrt",
		       "sm_killstreak_rstrt",
		       ACCESS_CONSOLE, "");
    plugin_registercmd("sm_killstreak_stats",
		       "sm_killstreak_stats",
		       ACCESS_CONSOLE, "");

    exec("sm_register ResetHUD ^"admin_command sm_killstreak_rstrt^" bd");
    exec("sm_register DeathMsg ^"admin_command sm_killstreak_event^" ad");

    return PLUGIN_CONTINUE;
}
